//Builder Pattern
using TDD_Section1.WebAPI.Implements;
using TDD_Section1.WebAPI.interfaces;

var builder = WebApplication.CreateBuilder(args);

//Configuration
var configuration = builder.Configuration;
var dbconnection = configuration.GetConnectionString("DefaultConnection");
var dbConnection2 = configuration["ConnectionStrings:DefaultConnection"];
configuration.AddJsonFile("milad1.json",
    optional:true,reloadOnChange:true);
configuration.AddEnvironmentVariables();

//Logging
builder.Logging.AddConsole();
builder.Logging.AddEventSourceLogger();
builder.Logging.AddDebug();

//Service Collection(DI Container)
// Add services to the container.
builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

/// AddSingleton - AddScoped - AddTransient

builder.Services.AddTransient<IGuidProvider, GuidProvider>();

//Middleware Pipeline
var app = builder.Build();
// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}
app.UseHttpsRedirection();
app.UseAuthorization();
app.MapControllers();
app.UseCors();

//Run Application
app.Run();
